#pragma implementation

#include "DebtagsFilter.h"
#include "DebtagsPackage.h"

using namespace std;
using namespace Debtags;

Filter::~Filter() throw ()
{
	if (str) delete str;
}

void Filter::setName(const std::string _name) throw ()
{
	try {
		if (_name.empty())
		{
			if (name) delete name;
			name = 0;
		} else
			name = new Regexp(_name);
	} catch (RegexpException& e) {
		fprintf(stderr, "%s: %.*s\n", e.type(), PFSTR(e.desc()));
		name = 0;
	}
}

void Filter::setString(const std::string _str) throw ()
{
	try {
		if (_str.empty())
		{
			if (str) delete str;
			str = 0;
		} else
			str = new Regexp(_str);
	} catch (RegexpException& e) {
		fprintf(stderr, "%s: %.*s\n", e.type(), PFSTR(e.desc()));
		str = 0;
	}
}

bool Filter::matchName(const std::string& text) const throw ()
{
	if (name == 0)
		return true;
	return name->match(text);
}
bool Filter::matchMaintainer(const std::string& text) const throw ()
{
	if (maint.empty())
		return true;
	return text.find(maint) != string::npos;
}
bool Filter::matchString(const std::string& text) const throw ()
{
	if (str == 0)
		return true;
	return str->match(text);
}
bool Filter::matchInstalled(int status) const throw ()
{
	if (installed == ANY)
		return true;
	if (installed == YES && status != 0 && status != 5)
		return true;
	if (installed == NO && (status == 0 || status == 5))
		return true;
	return false;
}
bool Filter::matchDebtags(const OpSet<std::string>& ptags) const throw ()
{
	if (tags.empty())
		return true;
	return ptags.contains(tags);
}
bool Filter::matchPackage(Package* pkg) const throw ()
{
	/*
	bool got = false;
	//if (matchMaintainer(pkg->maint))
		//got = true;
	if (!got && matchString(pkg->name()))
		got = true;
	if (!got && matchString(pkg->desc()))
		got = true;
	if (!got && matchString(pkg->ldesc()))
		got = true;
	return got;
	*/
}

// vim:set ts=4 sw=4:
